;                          ____    ____
;                    MCLR |    \__/    | B7  PGD
;          ZUMMER <--  A0 |            | B6  PGC
;    FUSE MONITOR -->  A1 |            | B5  N.C.
;            N.C. <--  A2 |            | B4  N.C.
;            N.C. <--  A3 |            | B3  --> INTERNAL LED 1
;            N.C. <--  A4 |            | B2  N.C.
;  INTERNAL LED 2 <--  A5 |    2525    | B1  N.C.
;                     Vss |            | B0  N.C.
;             16 MHz  Osc |            | Vdd
;             16 MHz  Osc |            | Vss
;  MAIN LED 1 RED <--  C0 |            | C7 <--  RXD
;          RELE 1 <--  C1 |            | C6  --> TXD
;  MAIN LED 3 YEL <--  C2 |            | C5 <--  RD/WR SW IN
; MAIN LED 2 BLUE <--  C3 |____________| C4 <--  KEY IN

;_ _ _ _ _ _ _ _ _ _
;_ _ _ _ _ _ _ _ _ _

	LIST P=18F2525
	#include <P18F2525.INC>

#define	zumer		lata,0
#define	rele1		latc,1
#define	led_red		latc,0
#define	led_yel		latc,3
#define	led_blue	latc,2
#define	led_a		latb,3
#define	led_b		lata,5
#define fuse		porta,1
#define	key		portc,4
#define	sw		portc,5

	config osc = HS
	config fcmen = off
	config ieso = off
	config pwrt = on
	config borv = 1
	config wdt = off
	config mclre = off
	config lpt1osc = off
	config pbaden = off
	config stvren = on
	config lvp = off
	config xinst = off
	config debug = off
	config cp0 = off
	config cp1 = off
	config cp2 = off
	config cpb = off
	config cpd = off
	config wrt0 = on
	config wrt1 = on
	config wrt2 = on
	config wrtb = on
	config wrtc = on
	config wrtd = off
	config ebtr0 = off
	config ebtr1 = off
	config ebtr2 = off
	config ebtrb = off

	CBLOCK	0


flag		; 0 = za trazenje broja kartice u FIELD, set ako je <>
		; 1 = set ako je WR mode (prekidac ukljucen)
		; 2 = toggler za 2 Hz kad sve blinkuje BROJ puta
		; 3 = handshaking zahtev za upis u EE
tempw
inner
outer
uniform
rotorsw		; rotor prekidaca rd/wr, 100 hz
rotorkey	; rotor tastera, 100 Hz u RD modu i 6,25 Hz u WR modu
count		; koliko bajtova cita iz EE
redcount	; brojac za crveni led, 25 Hz, ako je =255 onda ne umanjuje
yelcount	; brojac za zuti led, 25 Hz, ako je =255 onda ne umanjuje
bluecount	; brojac za plavi led, 25 Hz, ako je =255 onda ne umanjuje
beepcount	; brojac za beep, 25 Hz
beepblinkcount	; brojac za isprekidani beep, 2 Hz
relecount	; brojac za rele, 25 Hz
allcount	; brojac da sve diode i zumer blinkuju BROJ puta
lastbuf: 5	; prethodni primljeni sadrzaj kartice

a5c3: 2		; prva dva bajta RX bafera, tu treba detektovati 0a5h i 0c3h VEZANO!
rxbuf: 5	; primljeni sadrzaj kartice                                  VEZANO!

broj		; 1 by broj memorisanih kartica, VEZANO!!!
field: 200	; za ukupno 40 kartica po 5 by,  VEZANO!!!

	ENDC

;_____________________________________________________________

	org	0
	nop
	goto	main

;_____________________________________________________________ INT (TIMER 2)

	org	8
				; 512 Hz heartbeat ticks
	incf	uniform,f

;			 	  beep blink zumer						
	movf	beepblinkcount,f
	bz	nobblink   ; \

	movf	uniform,w
	andlw	07fh
	bnz	nobb1
				; here 4 Hz
	btfsc	status,z
	bsf	zumer		; zumer on
nobb1
	xorlw	.40		; toliko traje svaki beep
	bnz	nobblink
	decf	beepblinkcount,f
	bcf	zumer		; zumer off
nobblink		   ; /
;-------




;												
	movf	uniform,w
	andlw	03h
	bnz	no100hz
				; 128 hz here
	bcf	status,c
	btfsc	sw
	bsf	status,c
	rlcf	rotorsw,f
	movf	rotorsw,w
	btfsc	status,z
	bsf	flag,1		; switch to WR mode
	incf	rotorsw,w
	btfss	status,z
	bra	notrdmode
	btfss	flag,1
	bra	notrdmode
				; JUST RD MODE here
	movf	broj,w
	movwf	allcount	; da sve blinkuje BROJ puta
	bcf	flag,1		; switch to RD mode

	bsf	flag,3		; zahtev za upis u EE

	goto	exit
notrdmode
;------
	btfsc	flag,1
	bra	inwrmode
				; RD mode				
	bcf	status,c
	btfsc	key
	bsf	status,c
	rlcf	rotorkey,f
	movf	rotorkey,w
	xorlw	b'11111110'
	movlw	.160		; za 5 sec brava on
	btfsc	status,z
	movwf	relecount	; key just hit in RD  mode
	bra	exkey
inwrmode			; WR mode
	movf	uniform,w
	andlw	07fh
	bnz	exkey
				; 4 Hz here				
	bcf	status,c
	btfsc	key
	bsf	status,c
	rlcf	rotorkey,f
	movf	rotorkey,w
	xorlw	b'10000000'
	bnz	exkey
				; key hit 1 sec in WR mode
	clrf	broj		; brise sve memorisane brojeve
	movlw	.32		; K/32 sec
	movwf	redcount	; pali crveni led
	movlw	.32
	movwf	beepcount
exkey
no100hz;										

	movf	uniform,w
	andlw	0fh
	bnz	no25hz
				; 32 hz here
;			 	  ALL off-on (ledovi i zumer)					
	movf	allcount,f
	bz	noall	   ; \

	movf	uniform,w
	andlw	0ffh
	bnz	idleall
				; here 2 Hz
	btg	flag,2
	btfss	flag,2
	bra	bcall

	bsf	zumer		; zumer on
	bsf	led_red		; red led on
	bsf	led_yel		; yel led on
	bsf	led_blue	; blue led on
	bra	exall
bcall
	decf	allcount,f

	bcf	zumer		; zumer off
	bcf	led_red		; red led off
	bcf	led_yel		; yel led off
	bcf	led_blue	; blue led off
exall
	clrf	beepcount
	clrf	redcount
	clrf	yelcount
	clrf	bluecount
idleall
	goto	skipall

noall			   ; /
;			 	  zumer off-on
	movf	beepblinkcount,f
	bnz	ex0		; ako je beepblinkcount aktivan
	movf	beepcount,f
	bz	bc0
	decf	beepcount,f
	bsf	zumer		; zumer on
	bra	ex0
bc0
	bcf	zumer		; zumer off
ex0
;			 	  red led off-on
	incf	redcount,w
	bz	on1		; ako je 255, onda ne umanjuje
	movf	redcount,f
	bz	bc1
	decf	redcount,f
on1
	bsf	led_red		; red led on
	bra	ex1
bc1
	bcf	led_red		; red led off
ex1
;			 	  yel led off-on
	incf	yelcount,w
	bz	on2		; ako je 255, onda ne umanjuje
	movf	yelcount,f
	bz	bc2
	decf	yelcount,f
on2
	bsf	led_yel		; yel led on
	bra	ex2
bc2
	bcf	led_yel		; yel led off
ex2
;			 	  blue led off-on
	incf	bluecount,w
	bz	on3		; ako je 255, onda ne umanjuje
	movf	bluecount,f
	bz	bc3
	decf	bluecount,f
on3
	bsf	led_blue	; blue led on
	bra	ex3
bc3
	bcf	led_blue	; blue led off
ex3
skipall
;			 	  rele1 off-on
	movf	relecount,f
	bz	bcrele1
	decf	relecount,f
	bsf	rele1		; rele1 on
	bra	exrele1
bcrele1
	bcf	rele1		; rele1 off
exrele1

no25hz;												

	movf	redcount,f
	bnz	exit
	movf	allcount,f
	bnz	exit
	btfss	flag,1
	bra	exit
				; ovde je redcount=0 i allcount=0 i WR mode
	movf	uniform,w
	btfsc	status,z
	bsf	led_red		; kratko blinka red led
	btfsc	status,z
	bsf	led_yel		; kratko blinka yel led
	btfsc	status,z
	bsf	led_blue	; kratko blinka blue led
exit
	bcf	pir1,tmr2if	; reset tmr2 interrupt flag
	retfie	fast

;_____________________________________________________________		
;_____________________________________________________________ MAIN	
;									

main:
	movlw	0fh
	movwf	adcon1
	movlw	7
	movwf	cmcon

	movlw	b'01001101'
	movwf	t2con		; prescaler=4, postscaler=10
	movlw	.195		; za oko 512 Hz (osc 16 MHz)
	movwf	pr2		; int na 1950t = 2+ ms = 512 Hz
	movlw	b'00000010'
	movwf	pie1		; enable timer2 int

	movlw	b'00100110'
	movwf	txsta		; reg TXREG
	movlw	b'10010000'
	movwf	rcsta		; reg RCREG
	movlw	.208
	movwf	spbrg		; 4800 bd (osc 16 MHz)

	movlw	b'10000100'	; t0 on, 16-bit, prescaler 1:32 (oko 524 ms)
	movwf	t0con		; timer0 (flag intcon,tmr0if)

	movlw	b'00100000'
	movwf	lata
	movlw	b'00001000'
	movwf	latb
	movlw	b'00000000'
	movwf	latc
	movlw	B'11000010'
	movwf	trisa
	movlw	B'00000000'
	movwf	trisb
	movlw	B'10110000'
	movwf	trisc
				; clear ram bank 0
	clrf	fsr1h
	clrf	fsr2h
	lfsr	fsr0,0
goclr256
	clrf	postinc0
	btfss	fsr0h,0
	goto	goclr256

	movf	rcreg,w		; rx reg read
	movf	rcreg,w		; rx reg read

	clrf	tmr0h
	clrf	tmr0l
	movlw	b'11000000'	; int enable
	movwf	intcon

	call	rdeexx		; prepisuje iz ee u BROJ i FIELD

;______________________________________________        _________________
;______________________________________________  FARM  _________________
;									

farm
	btfsc	pir1,rcif
	bra	stigao.rx
	btfsc	flag,3
	bra	zahtev.za.upis
	bra	farm

;				zahtev za upis
zahtev.za.upis
	bcf	flag,3
	call	wree2
	bra	farm

;				stigao rx byte
stigao.rx
	bcf	pir1,rcif
	movff	a5c3+1,a5c3+0
	movff	rxbuf+0,a5c3+1
	movff	rxbuf+1,rxbuf+0
	movff	rxbuf+2,rxbuf+1
	movff	rxbuf+3,rxbuf+2
	movff	rxbuf+4,rxbuf+3
	movff	rcreg,rxbuf+4

	movlw	0a5h
	cpfseq	a5c3+0
	bra	farm

	movlw	0c3h
	cpfseq	a5c3+1
	bra	farm
				; ovde je detektovao header a5c3, u rxbuf je sadrzaj kartice
	clrf	tmr0h
	clrf	tmr0l
	btfsc	intcon,tmr0if
	bra	prvistream	; jer je isteklo 0,5s od poslednje poruke
				; ovde je 2,3,4... poruka u nizu
	movf	rxbuf+0,w
	xorwf	lastbuf+0,w
	bnz	prvistream	; nisu iste poruke
	movf	rxbuf+1,w
	xorwf	lastbuf+1,w
	bnz	prvistream	; nisu iste poruke
	movf	rxbuf+2,w
	xorwf	lastbuf+2,w
	bnz	prvistream	; nisu iste poruke
	movf	rxbuf+3,w
	xorwf	lastbuf+3,w
	bnz	prvistream	; nisu iste poruke
	movf	rxbuf+4,w
	xorwf	lastbuf+4,w
	bnz	prvistream	; nisu iste poruke
	goto	farm		; jer je poruka u nizu koja je ista sa prethodnom
prvistream
	bcf	intcon,tmr0if

	movff	rxbuf+0,lastbuf+0
	movff	rxbuf+1,lastbuf+1
	movff	rxbuf+2,lastbuf+2
	movff	rxbuf+3,lastbuf+3
	movff	rxbuf+4,lastbuf+4

	call	findcard	; nalazi rxbuf (5) u field (BROJ), NC=nasao, COUNT=broj kartice
	bnc	postoji

	; ----------------------- stigao sadrzaj ispravne kartice koji NE POSTOJI u bazi	
	btfsc	flag,1
	bra	writebase
				; RD mode, a broj ne postoji u bazi
	movlw	.64		; K/32 sec
	movwf	redcount	; pali crveni led
	movlw	.5		; toliko kratkoh bipova po 1/4 sec
	movwf	beepblinkcount	; ukljucuje zumer za kratke bipove
	clrf	uniform
;	movlw	.2		; K/32 sec
;	movwf	beepcount	; ukljucuje zumer
	goto	farm		; jer nije nasao broj u bazi field

writebase			; WR mode, a broj ne postoji u bazi: upisi ga u bazu!
	movlw	.40
	cpfslt	broj		; BROJ-40
	goto	farm		; jer je broj memorisanih kartica u bazi overflov (=40)

	movf	broj,w
	mullw	.5
	movf	prodl,w		; w = (BROJ) * 5
	addlw	field		; w = (BROJ) * 5 + #FIELD
	movwf	fsr0l
	clrf	fsr0h		; fsr0 points to field pos
	movff	rxbuf+0,postinc0
	movff	rxbuf+1,postinc0
	movff	rxbuf+2,postinc0
	movff	rxbuf+3,postinc0
	movff	rxbuf+4,postinc0
	incf	broj,f
	movlw	.64		; K/32 sec
	movwf	yelcount	; pali zuti led
	movlw	.32		; K/32 sec
	movwf	beepcount	; ukljucuje zumer
	goto	farm

postoji	; +++++++++++++++++++++++ stigao sadrzaj ispravne kartice koji POSTOJI u bazi		

	movlw	.160		; K/32 sec
	movwf	relecount	; ukljucuje rele
	movlw	.64		; K/32 sec
	movwf	bluecount	; pali plavi led
	movlw	.16		; K/32 sec
	movwf	beepcount	; ukljucuje zumer
	bra	farm





;									
;						SUBS			
;									

findcard			; pronalazi broj (rxbuf, 5 by) u (field, 40*5 by)
				; na izlazu NC=nasao, COUNT=broj kartice
				; testira samo (BROJ) kartica
	clrf	count
	movf	broj,w
	bz	notfound	; jer je broj upisanih kartica = 0
	movwf	outer		; brojac kartica za poredjenje, 0...39
	lfsr	fsr0,field
gofind40		   ; \
	movlw	.5
	movwf	inner		; brojac bajtova za poredjenje, 0...4
	lfsr	fsr1,rxbuf
	bcf	flag,0		; flag =
gofind5			   ; \\
	movf	postinc1,w	; iz rxbuf pointera
	xorwf	postinc0,w	; cp sa field pointer
	btfss	status,z
	bsf	flag,0		; flag <>
	decfsz	inner,f
	bra	gofind5	   ; //	; loop next byte

	btfss	flag,0
	bra	found		; pronasao jednaku karticu!

	incf	count,f		; adv broj testirane kartice
	decfsz	outer,f
	bra	gofind40   ; /	; nije ova kartica, loop next card
notfound
	bsf	status,c	; flag it not found
	return
found
	bcf	status,c	; flag it found
	return

;									
wree2				; upisuje BROJ u ee(0) i BROJ bajtova iz FIELD u ee(1...)
	bcf	led_a
	bcf	led_b
	bcf	intcon,gieh	; DI ---------
	bcf	intcon,giel	; DI ---------

	clrf	eeadr
	clrf	eeadrh

	movf	broj,w
	mullw	.5
	movf	prodl,w
	movwf	count		; jer upisuje x5 bajtova

	movf	broj,w
	call	wrwee		; upisuje BROJ u ee(0)

	movf	count,f
	bz	nowritee
	lfsr	fsr1,field
gowree2
	movf	postinc1,w
	call	wrwee	
	decfsz	count,f
	bnz	gowree2
nowritee
	bsf	intcon,giel	; EI ---------
	bsf	intcon,gieh	; EI ---------
	bsf	led_a
	bsf	led_b
	return
;------
wrwee				; upisuje W (samo 1 bajt) u EEADRH:EEADR, inc EEADRH:EEADR
	bcf	pir2,eeif
	clrf	eecon1
	movwf	eedata
	bsf	eecon1,wren
	nop
	nop
	movlw	55h
	movwf	eecon2
	movlw	0aah
	movwf	eecon2
	bsf	eecon1,wr
waitwr
	btfss	pir2,eeif
	bra	waitwr

	bcf	eecon1,wren
	bcf	pir2,eeif
	incf	eeadr,f
	btfsc	status,z
	incf	eeadrh,f
	return



;									

rdeexx				;   ***   read from EE to FIELD   ***
	call	rd1ee		; procitaj broj upisanih
	movwf	tempw
	addlw	-.40
	btfsc	status,c
	bra	mth40		; greska, broj upisanih je veci od 40

	movf	tempw,w
	bz	mth40		; broj upisanih = 0
	movwf	broj
	mullw	.5
	movf	prodl,w
	movwf	count		; toliko bajtova cita

	movlw	1
	movwf	eeadr
	clrf	eeadrh
	lfsr	fsr1,field
gordee
	clrf	eecon1
	bsf	eecon1,rd
	movff	eedata,postinc1
	incf	eeadr,f
	btfsc	status,z
	incf	eeadrh,f
	decfsz	count,f
	bra	gordee
	return

mth40
	clrf	broj
	return

;									

rd1ee				;   ***   read 1 byte from EE (address 0) to w   ***
	clrf	eeadr
	clrf	eeadrh
	clrf	eecon1
	bsf	eecon1,rd
	movf	eedata,w
	return


	END